"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var turbocolor_1 = __importDefault(require("turbocolor"));
var relativeId_1 = __importDefault(require("../../src/utils/relativeId"));
// log to stderr to keep `rollup main.js > bundle.js` from breaking
exports.stderr = console.error.bind(console); // eslint-disable-line no-console
function handleError(err, recover) {
    if (recover === void 0) { recover = false; }
    var description = err.message || err;
    if (err.name)
        description = err.name + ": " + description;
    var message = (err.plugin
        ? "(" + err.plugin + " plugin) " + description
        : description) || err;
    exports.stderr(turbocolor_1.default.bold.red("[!] " + turbocolor_1.default.bold(message.toString())));
    if (err.url) {
        exports.stderr(turbocolor_1.default.cyan(err.url));
    }
    if (err.loc) {
        exports.stderr(relativeId_1.default(err.loc.file || err.id) + " (" + err.loc.line + ":" + err.loc.column + ")");
    }
    else if (err.id) {
        exports.stderr(relativeId_1.default(err.id));
    }
    if (err.frame) {
        exports.stderr(turbocolor_1.default.dim(err.frame));
    }
    if (err.stack) {
        exports.stderr(turbocolor_1.default.dim(err.stack));
    }
    exports.stderr('');
    if (!recover)
        process.exit(1);
}
exports.handleError = handleError;
