"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var pretty_bytes_1 = __importDefault(require("pretty-bytes"));
var turbocolor_1 = __importDefault(require("turbocolor"));
function printTimings(timings) {
    Object.keys(timings).forEach(function (label) {
        var color = label[0] === '#' ? (label[1] !== '#' ? turbocolor_1.default.underline : turbocolor_1.default.bold) : function (text) { return text; };
        var _a = timings[label], time = _a[0], memory = _a[1], total = _a[2];
        var row = label + ": " + time.toFixed(0) + "ms, " + pretty_bytes_1.default(memory) + " / " + pretty_bytes_1.default(total);
        console.info(color(row));
    });
}
exports.printTimings = printTimings;
