"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ArrayExpression_1 = __importDefault(require("./ArrayExpression"));
var ArrayPattern_1 = __importDefault(require("./ArrayPattern"));
var ArrowFunctionExpression_1 = __importDefault(require("./ArrowFunctionExpression"));
var AssignmentExpression_1 = __importDefault(require("./AssignmentExpression"));
var AssignmentPattern_1 = __importDefault(require("./AssignmentPattern"));
var AwaitExpression_1 = __importDefault(require("./AwaitExpression"));
var BinaryExpression_1 = __importDefault(require("./BinaryExpression"));
var BlockStatement_1 = __importDefault(require("./BlockStatement"));
var BreakStatement_1 = __importDefault(require("./BreakStatement"));
var CallExpression_1 = __importDefault(require("./CallExpression"));
var CatchClause_1 = __importDefault(require("./CatchClause"));
var ClassBody_1 = __importDefault(require("./ClassBody"));
var ClassDeclaration_1 = __importDefault(require("./ClassDeclaration"));
var ClassExpression_1 = __importDefault(require("./ClassExpression"));
var ConditionalExpression_1 = __importDefault(require("./ConditionalExpression"));
var DoWhileStatement_1 = __importDefault(require("./DoWhileStatement"));
var EmptyStatement_1 = __importDefault(require("./EmptyStatement"));
var ExportAllDeclaration_1 = __importDefault(require("./ExportAllDeclaration"));
var ExportDefaultDeclaration_1 = __importDefault(require("./ExportDefaultDeclaration"));
var ExportNamedDeclaration_1 = __importDefault(require("./ExportNamedDeclaration"));
var ExpressionStatement_1 = __importDefault(require("./ExpressionStatement"));
var ForInStatement_1 = __importDefault(require("./ForInStatement"));
var ForOfStatement_1 = __importDefault(require("./ForOfStatement"));
var ForStatement_1 = __importDefault(require("./ForStatement"));
var FunctionDeclaration_1 = __importDefault(require("./FunctionDeclaration"));
var FunctionExpression_1 = __importDefault(require("./FunctionExpression"));
var Identifier_1 = __importDefault(require("./Identifier"));
var IfStatement_1 = __importDefault(require("./IfStatement"));
var Import_1 = __importDefault(require("./Import"));
var ImportDeclaration_1 = __importDefault(require("./ImportDeclaration"));
var LabeledStatement_1 = __importDefault(require("./LabeledStatement"));
var Literal_1 = __importDefault(require("./Literal"));
var LogicalExpression_1 = __importDefault(require("./LogicalExpression"));
var MemberExpression_1 = __importDefault(require("./MemberExpression"));
var MetaProperty_1 = __importDefault(require("./MetaProperty"));
var MethodDefinition_1 = __importDefault(require("./MethodDefinition"));
var NewExpression_1 = __importDefault(require("./NewExpression"));
var ObjectExpression_1 = __importDefault(require("./ObjectExpression"));
var ObjectPattern_1 = __importDefault(require("./ObjectPattern"));
var Program_1 = __importDefault(require("./Program"));
var Property_1 = __importDefault(require("./Property"));
var RestElement_1 = __importDefault(require("./RestElement"));
var ReturnStatement_1 = __importDefault(require("./ReturnStatement"));
var SequenceExpression_1 = __importDefault(require("./SequenceExpression"));
var Node_1 = require("./shared/Node");
var SpreadElement_1 = __importDefault(require("./SpreadElement"));
var SwitchCase_1 = __importDefault(require("./SwitchCase"));
var SwitchStatement_1 = __importDefault(require("./SwitchStatement"));
var TaggedTemplateExpression_1 = __importDefault(require("./TaggedTemplateExpression"));
var TemplateElement_1 = __importDefault(require("./TemplateElement"));
var TemplateLiteral_1 = __importDefault(require("./TemplateLiteral"));
var ThisExpression_1 = __importDefault(require("./ThisExpression"));
var ThrowStatement_1 = __importDefault(require("./ThrowStatement"));
var UnaryExpression_1 = __importDefault(require("./UnaryExpression"));
var UnknownNode_1 = __importDefault(require("./UnknownNode"));
var UpdateExpression_1 = __importDefault(require("./UpdateExpression"));
var VariableDeclaration_1 = __importDefault(require("./VariableDeclaration"));
var VariableDeclarator_1 = __importDefault(require("./VariableDeclarator"));
var WhileStatement_1 = __importDefault(require("./WhileStatement"));
var YieldExpression_1 = __importDefault(require("./YieldExpression"));
exports.nodeConstructors = {
    ArrayExpression: ArrayExpression_1.default,
    ArrayPattern: ArrayPattern_1.default,
    ArrowFunctionExpression: ArrowFunctionExpression_1.default,
    AssignmentExpression: AssignmentExpression_1.default,
    AssignmentPattern: AssignmentPattern_1.default,
    AwaitExpression: AwaitExpression_1.default,
    BinaryExpression: BinaryExpression_1.default,
    BlockStatement: BlockStatement_1.default,
    BreakStatement: BreakStatement_1.default,
    CallExpression: CallExpression_1.default,
    CatchClause: CatchClause_1.default,
    ClassBody: ClassBody_1.default,
    ClassDeclaration: ClassDeclaration_1.default,
    ClassExpression: ClassExpression_1.default,
    ConditionalExpression: ConditionalExpression_1.default,
    DoWhileStatement: DoWhileStatement_1.default,
    EmptyStatement: EmptyStatement_1.default,
    ExportAllDeclaration: ExportAllDeclaration_1.default,
    ExportDefaultDeclaration: ExportDefaultDeclaration_1.default,
    ExportNamedDeclaration: ExportNamedDeclaration_1.default,
    ExpressionStatement: ExpressionStatement_1.default,
    ForStatement: ForStatement_1.default,
    ForInStatement: ForInStatement_1.default,
    ForOfStatement: ForOfStatement_1.default,
    FunctionDeclaration: FunctionDeclaration_1.default,
    FunctionExpression: FunctionExpression_1.default,
    Identifier: Identifier_1.default,
    IfStatement: IfStatement_1.default,
    Import: Import_1.default,
    ImportDeclaration: ImportDeclaration_1.default,
    LabeledStatement: LabeledStatement_1.default,
    Literal: Literal_1.default,
    LogicalExpression: LogicalExpression_1.default,
    MemberExpression: MemberExpression_1.default,
    MetaProperty: MetaProperty_1.default,
    MethodDefinition: MethodDefinition_1.default,
    NewExpression: NewExpression_1.default,
    ObjectExpression: ObjectExpression_1.default,
    ObjectPattern: ObjectPattern_1.default,
    Program: Program_1.default,
    Property: Property_1.default,
    RestElement: RestElement_1.default,
    ReturnStatement: ReturnStatement_1.default,
    SequenceExpression: SequenceExpression_1.default,
    SpreadElement: SpreadElement_1.default,
    SwitchCase: SwitchCase_1.default,
    SwitchStatement: SwitchStatement_1.default,
    TaggedTemplateExpression: TaggedTemplateExpression_1.default,
    TemplateElement: TemplateElement_1.default,
    TemplateLiteral: TemplateLiteral_1.default,
    ThisExpression: ThisExpression_1.default,
    ThrowStatement: ThrowStatement_1.default,
    TryStatement: Node_1.StatementBase,
    UnaryExpression: UnaryExpression_1.default,
    UnknownNode: UnknownNode_1.default,
    UpdateExpression: UpdateExpression_1.default,
    VariableDeclarator: VariableDeclarator_1.default,
    VariableDeclaration: VariableDeclaration_1.default,
    WhileStatement: WhileStatement_1.default,
    YieldExpression: YieldExpression_1.default
};
