"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CHAR_CODE_A = 97;
var CHAR_CODE_0 = 48;
function intToHex(num) {
    if (num < 10)
        return String.fromCharCode(CHAR_CODE_0 + num);
    else
        return String.fromCharCode(CHAR_CODE_A + (num - 10));
}
function Uint8ArrayToHexString(buffer) {
    var str = '';
    // hex conversion - 2 chars per 8 bit component
    for (var i = 0; i < buffer.length; i++) {
        var num = buffer[i];
        // big endian conversion, but whatever
        str += intToHex(num >> 4);
        str += intToHex(num & 0xf);
    }
    return str;
}
exports.Uint8ArrayToHexString = Uint8ArrayToHexString;
function Uint8ArrayXor(to, from) {
    for (var i = 0; i < to.length; i++)
        to[i] = to[i] ^ from[i];
    return to;
}
exports.Uint8ArrayXor = Uint8ArrayXor;
function randomUint8Array(len) {
    var buffer = new Uint8Array(len);
    for (var i = 0; i < buffer.length; i++)
        buffer[i] = Math.random() * (2 << 8);
    return buffer;
}
exports.randomUint8Array = randomUint8Array;
function Uint8ArrayEqual(bufferA, bufferB) {
    for (var i = 0; i < bufferA.length; i++) {
        if (bufferA[i] !== bufferB[i])
            return false;
    }
    return true;
}
exports.Uint8ArrayEqual = Uint8ArrayEqual;
function randomHexString(len) {
    return Uint8ArrayToHexString(randomUint8Array(Math.floor(len / 2)));
}
exports.randomHexString = randomHexString;
