"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("./path");
function getAliasName(resolved, unresolved) {
    var alias = path_1.basename(unresolved || resolved);
    var ext = path_1.extname(resolved);
    if (alias.endsWith(ext))
        alias = alias.substr(0, alias.length - ext.length);
    return alias;
}
exports.getAliasName = getAliasName;
function relativeId(id) {
    if (typeof process === 'undefined' || !path_1.isAbsolute(id))
        return id;
    return path_1.relative(process.cwd(), id);
}
exports.default = relativeId;
function isPlainName(name) {
    // not starting with "./", "/". "../"
    if (name[0] === '/' ||
        (name[1] === '.' && (name[2] === '/' || (name[2] === '.' && name[3] === '/'))))
        return false;
    return true;
}
exports.isPlainName = isPlainName;
